unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, RXCtrls, RXSpin, Grids, Impstringgrid, Mask, ToolEdit,
  Buttons, ComCtrls, CheckLst,inifiles, ActnList, ShellApi;

type
  int=integer;

  TFile=class
  private
    fOwner:TObject;
    SecName:string;
  protected
    function GetIndex: Int;
    function GetFileName(ReplIndex:int):string;
    function GetStringRepl(Index:int):string;
    function ReplChecked(Index:int):boolean;
  public
    Repl:TStringList;
    Name:string;
    Descriprion:string;
    Enable:boolean;
    Check:boolean;
    property Index:Int read GetIndex;
    constructor Create(Aowner:Tobject);
    destructor Destroy;override;
    procedure FindOffsets(RootDir:string);
    procedure CreateCopy(RootDir:string;Index:int);
  end;

  TFileList=class(TList)
  private
    function GetFiles(Index: int): TFile;
    procedure SetFiles(Index: int; const Value: TFile);
  public
    property Files[Index:int]:TFile read GetFiles write SetFiles;
    procedure Clear; override;
    function Add:TFile;
    procedure LoadFromFile(FName:string);
    procedure FindOffsets(RootDir:string);
    function SectionIndex(Name:string):int;
  end;

  TForm1 = class(TForm)
    SecretPanel1: TSecretPanel;
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ProgressBar1: TProgressBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label3: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    Label2: TLabel;
    RxSpinEdit2: TRxSpinEdit;
    GroupBox1: TGroupBox;
    ImpStringgrid1: TImpStringgrid;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit1: TFilenameEdit;
    SecretPanel2: TSecretPanel;
    CheckBox2: TCheckBox;
    GroupBox2: TGroupBox;
    cbProgram: TCheckBox;
    cbDesktop: TCheckBox;
    CLB1: TCheckListBox;
    Desctext: TStaticText;
    TabSheet2: TTabSheet;
    Label4: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    ActionList1: TActionList;
    SetYes: TAction;
    SetNo: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RxSpinEdit1Change(Sender: TObject);
    procedure RxSpinEdit2Change(Sender: TObject);
    procedure ImpStringgrid1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure GroupBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CLB1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PageControl1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SetYesExecute(Sender: TObject);
    procedure SetNoExecute(Sender: TObject);
    procedure SetNoUpdate(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure CLB1ClickCheck(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
    FileList:TFileList;
    IsMultiInstance:boolean;
    procedure DetectICQLocation;
    procedure InitStringGrid;
    procedure resizegrid;
    procedure RenameRows;
    procedure Main;
    procedure InitFilesList;
    procedure CreateLink(FileName: string;UIN:integer;isDesktop,isProgram:boolean);
    procedure SetMulti(Yes:boolean);
  end;


var
  Form1: TForm1;
  curUIN:string='';
const
  Slash='\';
  ICQRegRoot='Software\Mirabilis\ICQ';
  own=Slash+'Owners';
  def=Slash+'DefaultPrefs';

resourcestring
  splash='ICQX       ICQ, '+
  '    . ICQX     ICQ2000.';


implementation
uses
  registry, cStreams ,ShlObj,ActiveX,ComObj;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  filelist:=TFileList.Create;
  DetectICQLocation;
  if curuin<>'' then
  begin
    InitFilesList;
    InitStringgrid;
    RxSpinEdit1.Value:=1;
    RenameRows;
//    ShowMessage(splash);
    with SecretPanel1.Lines do
      begin
        clear;
        Add(splash);
      end;
    SecretPanel1.Active:=true;
  end
end;

procedure TForm1.DetectICQLocation;
var
  tr:TRegIniFile;
  s:string;
begin
  tr:=TRegIniFile.Create;
  try
    IsMultiInstance:=tr.ReadString(ICQRegRoot+def,'MultiInstance','No')='Yes';
    s:=tr.ReadString(ICQRegRoot+def,'ICQPath','');
    if s[length(s)]<>Slash then s:=s+slash;
    edit1.text:=s+'icq.exe';
    if curuin='0' then
      curuin:='';
    tr.OpenKey(ICQRegRoot+own,false);
    tr.ReadSections(ImpStringgrid1.Columns.Items[1].PickList);
    curuin:=inttostr(TRegistry(tr).ReadInteger('LastOwner'));
  finally
    tr.free;
  end;
  
end;

procedure TForm1.InitStringGrid;
begin
  with ImpStringgrid1.Columns.Items[1] do
  begin
    ButtonStyle:=cbsPicklist;
    Title.Caption:='UIN';
    DropDownRows:=10;
    ReadOnly:=true;
  end;
  ImpStringgrid1.Columns.Items[0].Title.Caption:='Name';
  ImpStringgrid1.Cells[0,1]:='Icq.exe';
  ImpStringgrid1.Columns.Items[0].ReadOnly:=true;
  resizegrid;
end;

procedure TForm1.RenameRows;
var
  j,i:integer;

begin
  j:=RxSpinEdit2.AsInteger-2;
  with ImpStringgrid1 do
    for i:=1 to RowCount-1 do
      begin
        if i=1 then
        else
          cells[0,i]:='icq'+inttostr(i+j)+'.exe';
        if cells[1,i]='' then
          cells[1,i]:=curuin;
      end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if curuin='' then
    begin
      ShowMessage('    ICQ.     .');
      close;
    end;
end;

procedure TForm1.RxSpinEdit1Change(Sender: TObject);
begin
  ImpStringgrid1.RowCount:=2+RxSpinEdit1.AsInteger;
  resizegrid;
  RenameRows;
end;

procedure TForm1.RxSpinEdit2Change(Sender: TObject);
begin
  RenameRows;
end;

procedure TForm1.ImpStringgrid1Click(Sender: TObject);
begin
  ImpStringgrid1.EditorMode :=true;
end;

procedure TForm1.resizegrid;
var
  i:integer;
  function IsScrollVisible:boolean;
  var
    min,max:integer;
  begin
    GetScrollRange(ImpStringgrid1.Handle,SB_VERT,min,max);
    result:=max<>min;
  end;
const
  w:integer=6;
begin
  with ImpStringgrid1 do
  begin
    if BorderStyle=bsnone then
      w:=2;
    i:=Width-ColWidths[0]-GridLineWidth*w;
    if IsScrollVisible then
      i:=i-GetSystemMetrics(SM_CYVSCROLL);
    ColWidths[1]:=i;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  ImpStringgrid1.Enabled:=CheckBox1.Checked;
  with ImpStringgrid1 do
    if Enabled then
      color:=clwindow
    else
      color:=FixedColor;  

end;

procedure TForm1.GroupBox1Click(Sender: TObject);
begin
  CheckBox1.Checked:=not CheckBox1.Checked;
  CheckBox1Click(sender);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  GroupBox2.Enabled:= CheckBox2.Checked;
  cbProgram.Enabled:= CheckBox2.Checked;
  cbDesktop.Enabled:= CheckBox2.Checked;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  BitBtn1.Enabled:=false;
  BitBtn2.Enabled:=false;
  with ProgressBar1 do
  begin
    Position:=0;
    Max:=RxSpinEdit1.AsInteger*2;
    Main;
    Position:=0;
  end;
  BitBtn1.Enabled:=true;
  BitBtn2.Enabled:=true;
end;

procedure TForm1.CreateLink(FileName: string;UIN:integer;isDesktop,isProgram:boolean);
var
  IObject: IUnknown;
  SLink: IShellLink;
  PFile: IPersistFile;
  path:array [0..MAX_PATH-1] of WideChar;
  ws:WideString;

  function GetSpecFolderPath(wPath:PWideChar;nFolder:integer):boolean;
  var
    PIDL:PItemIDList;
  begin
    result:=(SHGetSpecialFolderLocation(Handle,nFolder,pidl)=NOERROR ) and
      SHGetPathFromIDListW(Pidl,wPAth);
  end;

begin
  CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER or
    CLSCTX_LOCAL_SERVER, IUnknown, IObject);
  SLink := IObject as IShellLink;
  PFile := IObject as IPersistFile;
  with SLink do begin
    SetDescription(Pchar('ICQ clone created by ICQX 4UIN: '+Inttostr(UIN)));
    SetWorkingDirectory(Pchar(ExtractFilePath(FileName)));
    SetPath(PChar(FileName));
    SetIconLocation(pchar(FileName),0);
  end;
  Filename:=ExtractFileName(Filename);
  Filename:=Slash+changefileext(FileName,'.lnk');
  ws:=FileName;
  if isDesktop then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_DESKTOP,false);
    if GetSpecFolderPath(@path[0],CSIDL_DESKTOP) then
      PFile.Save(pWideChar(Path+ws), FALSE);
  end;
  if isProgram then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_PROGRAMS,false);
    if GetSpecFolderPath(@path[0],CSIDL_PROGRAMS) then
      PFile.Save(pWideChar(path+'\ICQ'+ws), FALSE);
  end;
end;


procedure TForm1.Main;
const
  CoreS='Core.dll';
  MutexS='ICQ Mutex';
  lOwnerS='LastOwner';
  xc='ICQX';

  procedure MainReg(LO:string;UIN:integer);
  var
    r:treginifile;
  begin
    r:=TRegIniFile.Create;
    try
      r.OpenKey(ICQRegRoot+own,false);
      tregistry(r).WriteInteger(LO,UIN);
    finally
      r.free;
    end;

  end;
var
  s,dir:string;
  k,i,j:int;

begin
  dir:=extractfilepath(Edit1.Text);
  if RxSpinEdit1.AsInteger>0 then
    begin
      filelist.FindOffsets(dir);
      i:=RxSpinEdit2.AsInteger+RxSpinEdit1.AsInteger-1;
      while i>=RxSpinEdit2.AsInteger do
      try
        for k:=0 to filelist.Count-1 do
        if filelist.files[k].Check then
        begin
          Caption:=xc+' - '+filelist.files[k].name+' - '+inttostr(i);
          filelist.files[k].CreateCopy(dir,i);
          ProgressBar1.StepIt;
          application.ProcessMessages;
        end;
        if CheckBox2.Checked and (cbDesktop.Checked or cbProgram.Checked) then
        begin
          j:=i-RxSpinEdit2.AsInteger+2;
          j:=strtoint(ImpStringgrid1.Cells[1,j]);
          CreateLink(dir+'icq'+inttostr(i)+'.exe',j,cbDesktop.Checked,cbProgram.Checked);
        end;
        if CheckBox1.Checked then
        begin
          j:=i-RxSpinEdit2.AsInteger+2;
          j:=strtoint(ImpStringgrid1.Cells[1,j]);
          s:=inttostr(i);
          MainReg(format('%.*s%s',[length(lowners)-length(s),lowners,s]),j);
        end;
      finally
        dec(i);
      end;
    end;  
  caption:=xc;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.CLB1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i:int;
  s:string;
begin
  i:=clb1.ItemAtPos(point(x,y),true);
  if i<0 then
    s:='<=       .'
  else
    s:=filelist.Files[i].Descriprion;
  desctext.Caption:=s;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  bitbtn1.Enabled:=pagecontrol1.ActivePageIndex=0;
end;

{ TFile }

constructor TFile.Create(AOwner:tObject);
begin
  inherited Create;
  fowner:=Aowner;
  Repl:=TStringList.Create;
end;

procedure TFile.CreateCopy(RootDir: string; Index: int);
var
  ss:cStreams.tfilestream;
  num:string;
  i,p:int;

  function CreateFile(Dir:string;Name:string;Index:int):string;
  var
    src,dest,num:string;
    i:int;
  begin
    result:='';
    src:=dir+name;
    if not fileexists(src) then exit;
    num:=inttostr(index);
    if name='icq.exe' then
      dest:=dir+'icq'+num+'.exe'
    else
    begin
      dest:=src;
      i:=LastDelimiter('.',dest);
      if i<0 then
        dest:=dest+num
      else
        dest:=copy(dest,1,i-1-length(num))+num+copy(dest,i,length(dest));
    end;
    result:=dest;
    if FileExists(dest) then exit;
    copyfile(pchar(src),PChar(dest),false);
  end;
begin
  num:=inttostr(index);
  for i:=0 to pred(repl.count) do
    if ReplChecked(i) then
    begin
      ss:=cStreams.tfilestream.Create(CreateFile(RootDir,GetFileName(i),index),[]);
      try
        p:= int(repl.Objects[i]);
        if p<0 then continue;
        if repl.Values[repl.Names[i]][1]='L' then
          dec(p,length(num));
        ss.Position:=p;
        ss.Write(num);
      finally
        ss.free;
      end;
    end;
end;

destructor TFile.Destroy;
begin
  repl.free;
  inherited;
end;

procedure TFile.FindOffsets(RootDir: string);
var
  i,p:int;
  s:string;
  ss:cStreams.tfilestream;
  fname:string;
begin
  for i:=0 to repl.Count-1 do
  begin
    fname:=GetFileName(i);
    if not fileexists(rootdir+fName) then exit;
    ss:=cStreams.tfilestream.Create(RootDir+fName,[]);
    try
      p:=ss.Locate(GetstringRepl(i));
      if p>=0 then
      begin
        s:=repl.Values[repl.Names[i]];
        inc(p,strtoint(copy(s,2,length(s))));
      end;
      repl.Objects[i]:=TObject(p);
    finally
      ss.Free;
    end;
  end;
end;

function TFile.GetFileName(ReplIndex: int): string;
var
  p:int;
begin
  result:=repl.Names[ReplIndex];
  p:=ansipos(',',result);
  if p>0 then
  begin
    result:=copy(result,1,p-1);
    p:=(fowner as TFileList).SectionIndex(result);
    if p<0 then
      raise exception.Create(Name+': '+result + ' - no such section')
    else
      result:=(fowner as TFileList).Files[p].Name
  end
  else
    result:=name;
end;

function TFile.GetIndex: Int;
begin
  result:=(fowner as TList).IndexOf(self);
end;

function TFile.GetStringRepl(Index: int): string;
begin
  result:=repl.Names[index];
  index:=ansipos(',',result);
  if index>0 then
    result:=copy(result,index+1,length(result))
end;

function TFile.ReplChecked(Index: int): boolean;
var
  s:string;
begin
  s:=repl.Names[Index];
  Index:=ansipos(',',s);
  if Index>0 then
  begin
    s:=copy(s,1,Index-1);
    index:=(fowner as TFileList).SectionIndex(s);
    if index<0 then
      result:=false
    else
      result:=(fowner as TFileList).Files[index].Check;
  end
  else
    result:=self.Check;
end;

{ TFileList }

function TFileList.Add: TFile;
begin
  result:=TFile.Create(Self);
  inherited add(result);
end;

procedure TFileList.Clear;
var
  i:int;
begin
  for i:=0 to  count-1 do
    Files[i].Free;
  inherited;  
end;

procedure TFileList.FindOffsets(RootDir: string);
var
  i:int;
begin
  for i:=0 to count-1 do
    files[i].FindOffsets(RootDir);
end;

function TFileList.GetFiles(Index: int): TFile;
begin
  result:=TFile(inherited items[index]);
end;

procedure TFileList.LoadFromFile(FName: string);
var
  r:TMemIniFile;
  st:TStringList;
  i,k:int;
  tf:tFile;
begin
  Clear;
  r:=TMemIniFile.Create(FName);
  try
    st:=TStringList.Create;
    try
      r.ReadSections(st);
      for i:=0 to st.Count-1 do
      begin
        tf:=add;
        tf.SecName:=st[i];
        tf.Name:=r.ReadString(st[i],'Name','');
        if tf.Name='' then
          delete(tf.index)
        else
        begin
          tf.Descriprion:=r.ReadString(st[i],'Desc','');
          tf.Enable:=r.ReadInteger(st[i],'Enable',1)=1;
          tf.Check:=r.ReadInteger(st[i],'Check',1)=1;
          k:=1;
          while r.ValueExists(st[i],'Find'+inttostr(k)) do
          begin
            tf.Repl.Add(r.ReadString(st[i],'Find'+inttostr(k),'')+'='+
                        r.ReadString(st[i],'Repl'+inttostr(k),''));
            inc(k);
          end;
        end;
      end;
    finally
      st.Free
    end;
  finally
    r.free;
  end;
end;

function TFileList.SectionIndex(Name: string): int;
begin
  result:=count-1;
  while (files[result].SecName<>name) and not (result<0) do
    dec(result);
end;

procedure TFileList.SetFiles(Index: int; const Value: TFile);
begin
  inherited Items[index]:=Value;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  filelist.Free;
end;

procedure TForm1.InitFilesList;
var
  i,k:int;
begin
  clb1.Clear;
  Filelist.LoadFromFile(extractfilepath(application.ExeName)+'Files.ini');
  for i:=0 to filelist.count-1 do
  begin
    k:=clb1.Items.Add(filelist.Files[i].Name);
    clb1.ItemEnabled[k]:=filelist.Files[i].Enable;
    clb1.Checked[k]:=filelist.Files[i].Check;
  end;
{  if filelist.count<2 then exit;
  clb1.ItemEnabled[0]:=false;
  clb1.Checked[0]:=true;
  clb1.ItemEnabled[1]:=false;
  clb1.Checked[1]:=true;}
end;

procedure TForm1.SetMulti(Yes: boolean);
var
  tr:TRegIniFile;
const
  ar:array[false..true] of string = ('No','Yes');  
begin
  tr:=TreginiFile.Create;
  try
    tr.WriteString(ICQRegRoot+def,'MultiInstance',ar[Yes]);
    IsMultiInstance:=Yes;
  finally
    tr.Free
  end;
end;

procedure TForm1.SetYesExecute(Sender: TObject);
begin
  SetMulti(true);
end;

procedure TForm1.SetNoExecute(Sender: TObject);
begin
  SetMulti(false);
end;

procedure TForm1.SetNoUpdate(Sender: TObject);
begin
  SetYes.Enabled:=not IsMultiInstance;
  SetNo.Enabled:=IsMultiInstance;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  shellExecute(Application.Handle,'open','mailto:tirna@narod.ru?subject=ICQX',nil,nil,SW_SHOW);
end;

procedure TForm1.CLB1ClickCheck(Sender: TObject);
begin
  if CLB1.ItemIndex<0 then exit;
  filelist.Files[CLB1.ItemIndex].Check:=CLB1.Checked[CLB1.ItemIndex];
end;

end.
